#include <rxduino.h>
#include <iodefine_gcc63n.h>
#include <intvect.h>
#include <sdmmc.h>

SDMMC mySD;

int timer_count = 0;
volatile int timer_div_flag = 0;
int on = 0;
long voice_samples = 0;
volatile int on_time = 1200;
volatile int off_time = 1200;
int sample_val = 0;
volatile unsigned char val = 0;
int pwm = 0;
int playback = 0;

void Excep_TMR0_CMIA0(void) __INTTERUPT_FUNC;
void initIntervalTimer();

void setup()
{
    pinMode(7, OUTPUT);
    pinMode(9, OUTPUT);
    pinMode(8, INPUT);
    
    digitalWrite(7, 0);
    digitalWrite(9, 0);
    analogReference(EXTERNAL);
    mySD.begin();
    initIntervalTimer();
    
    on_time = 1200;
    off_time = 1200;  
    playback = 0;
    mySD.remove("sample2.txt");
    File myFile = mySD.open("sample2.txt", FILE_WRITE);
    
    while(!digitalRead(8));
    delay(50);
    digitalWrite(9, 1);
    for(voice_samples = 0; digitalRead(8); voice_samples ++)
    {
        while(!timer_div_flag);
        myFile.write(val);
        while(timer_div_flag);
    }  
    digitalWrite(9, 0);      
    myFile.close();
    
    File myFile2 = mySD.open("sample2.txt", FILE_READ);
    TMR1.TCCR.BYTE = 0b01000;
    delay(2000);
    val = 0;
    on_time = 1200;
    off_time = 1200;  
    playback = 1;
    for(; voice_samples; voice_samples --)
    {
        while(!timer_div_flag);
        val = myFile2.read();
        while(timer_div_flag);
    }
    playback = 0;
    myFile2.close();
}

void loop()
{
    ;
}

void Excep_TMR0_CMIA0(void)
{   
    if(on)
    {    
         if(playback)
         {
             digitalWrite(7, on);
             sample_val = val * 4;
             
             if(sample_val - 785)
             {
                pwm = sample_val - 785;
                pwm = pwm * 8;
                on_time = 1200 + pwm;
                off_time = 1200 - pwm;
                TMR01.TCORA = on_time;
             }
             else
             {
                pwm = 785 - sample_val;
                pwm = pwm * 8;
                on_time = 1200 - pwm;
                off_time = 1200 + pwm;  
                TMR01.TCORA = on_time;
             }
         }
         else
         {
                 sample_val = analogRead(A0);
                 val = sample_val / 4;
         }
         on = 0;
    }
    else
    {
         if(playback)
         {
             digitalWrite(7, on);
             TMR01.TCORA = off_time;
         }
         else;
         
         timer_count ++;
         if(timer_count == 1)
         {
             timer_count = 0;
             timer_div_flag = ~timer_div_flag;
         }
         on = 1; 
    } 
}

void initIntervalTimer()
{
    MSTP(TMR0) = 0; // TMR01 enable
    TMR1.TCCR.BYTE = 0; // TMR1 clock disable
    TMR0.TCCR.BIT.CSS = 0b11; // 
    TMR01.TCNT = 0; // initialize count
    TMR0.TCR.BIT.CCLR = 0b01; // use TCORA
    TMR0.TCR.BIT.CMIEA = 1; // enable interrupt
    IEN(TMR0, CMIA0) = 1; // enable CMIA0
    IPR(TMR0, CMIA0) = 1; // interrupt level 1 
//    TMR01.TCORA = 125 * (48000000 / 8 / 1000000) - 1;// 125us
    TMR01.TCORA = 25 * (48000000 / 1000000) - 1;// 20KHz = 50uS; 25us ON Time + 25 us OFF Time
    TMR1.TCCR.BYTE = 0b01001;
}
